=begin
(c) TIG 2011
conex(height,angle,{segs})
or with NO arguments conex >> dialog
The 'angle' is the 'apex angle' NOT the 'slope'.
The origin is the 'apex' NOT the base-center.
=end
require 'sketchup.rb'
###
class Conex
def Conex::make(height=nil, angle=nil, segs=36)
  if not height or not angle ### use dialog
    prompts=["Height: ", "Angle: ", "Segments: "]
    values=[1000.mm, 60.0, 36]
    title="Conex Parameters"
    results=UI.inputbox(prompts, values, title)
    return nil if not results
    height, angle, segs = results
    height=1000.mm if height <=0
    angle=60.0 if angle <=0
    angle=60.0 if angle >=180
    segs=3 if segs <3
  #else ### we use arguments
  end#if
  model=Sketchup.active_model
  ents=model.active_entities
  model.start_operation("New Conex")
  radius=height*Math::tan(angle.degrees/2.0)
  cone=ents.add_group()
  cents=cone.entities
  ct=Geom::Point3d.new(0, 0, -height)
  cents.add_cpoint(ct)
  px=Geom::Point3d.new(0, 0, 0)### apex
  pc=Geom::Point3d.new(radius, 0, -height)
  circ=cents.add_circle(ct, Z_AXIS, radius, segs)
  face=cents.add_face(ct, px, pc)
  face.followme(circ)
  base=nil
  cents.each{|e|
    if e.class==Sketchup::Face and e.normal.z.abs==1
      base=e
      break
    end#if
  }
  cents.to_a.each{|e|e.reverse! if e.class==Sketchup::Face} if base.normal.z==1
  cone.set_attribute("Conex","height",height)
  cone.set_attribute("Conex","angle",angle)
  cone.set_attribute("Conex","segs",segs)
  model.commit_operation
  return cone
end
def Conex::edit(cone=nil)
  model=Sketchup.active_model
  cone=Conex.check() if not cone
  if not cone or not cone.valid?
    UI.messagebox("Edit Conex Parameters:\nYou must Select a suitable Conex to Edit!")
    return nil
  end#if
  model.start_operation("Edit Conex Parameters")
  height=cone.get_attribute("Conex","height",nil)
  angle=cone.get_attribute("Conex","angle",nil)
  segs=cone.get_attribute("Conex","segs",nil)
    prompts=["Height: ", "Angle: ", "Segments: "]
    values=[1000.mm, 60.0, 36]
    title="Conex Parameters"
    results=UI.inputbox(prompts, values, title)
    return nil if not results
    height, angle, segs = results
    height=1000.mm if height <=0
    angle=60.0 if angle <=0
    angle=60.0 if angle >=180
    segs=3 if segs <3
  tr=cone.transformation
  ncone=Conex.make(height, angle, segs)
  ncone.transform!(tr)
  ncone.layer=cone.layer
  ncone.material=cone.material
  ncone.set_attribute("Conex","height",height)
  ncone.set_attribute("Conex","angle",angle)
  ncone.set_attribute("Conex","segs",segs)
  cone.erase!
  model.commit_operation
  return
end
def Conex.check()
  model=Sketchup.active_model
  ss=model.selection
  cone=nil
  ss.each{|e|
    h=e.get_attribute("Conex","height",nil)
    a=e.get_attribute("Conex","angle",nil)
    s=e.get_attribute("Conex","segs",nil)
    if h and a and s
      cone=e
      break
    end#if
  }
  return cone
end

end#class
###
def conex(height=nil, angle=nil, segs=36)
  Conex.make(height=nil, angle=nil, segs=36)
end
### menu
if not file_loaded?(__FILE__)
    ### main_menu
    UI.menu("Draw").add_item("Conex"){Conex.make()}
    UI.menu("Draw").add_item("Edit Selected Conex"){Conex.edit()}
    ### context_menu
    cone=nil
    UI.add_context_menu_handler{|menu|menu.add_item("Edit Conex"){Conex.edit(cone)}}#if cone=Conex.check() # remove # if you can stand selection check delays
end#if
file_loaded(__FILE__)
###
